#!C:\Python25\python.exe

import time, datetime
from xml.dom.minidom import Document
import os, sys, zipfile, os.path
import xml.dom.minidom
from xml.dom.minidom import Node
import xml.sax
import pprint
import urllib2, urllib
import time, datetime

def log(message, mode="a"):
	global logFile
	s = datetime.datetime.now().ctime() + " | " + message
	l = open(logFile, mode)
	l.write(s.encode("utf-8")+"\n")
	l.close()
	print(s)


archiveFilename = sys.argv[1]
_dsa = sys.argv[2]

path = os.path.dirname( __file__ )+os.sep+_dsa+os.sep
if not os.path.exists(path):
	os.makedirs(path)
	
logFile = path+archiveFilename+".log"

log("archiveFile=" + path+archiveFilename, "w")

sys.stderr = sys.stdout


queryFile = path+archiveFilename + ".query.xml"
configFile = path+archiveFilename + ".config.xml"
dom = xml.dom.minidom.parse(configFile)
dsa = str(dom.getElementsByTagName("dsa")[0].firstChild.data)
url = str(dom.getElementsByTagName("wrapperurl")[0].firstChild.data)
ticket = str(dom.getElementsByTagName("ticket")[0].firstChild.data)


#
procFilename = path+archiveFilename + ".proc"
proc = open(procFilename, "w")
proc.write("Pid: "+str(os.getpid()))
proc.write("Process started "+datetime.datetime.now().ctime())
proc.close()

log("queryFile="+queryFile)
log("configFile="+configFile)
log("dsa="+dsa)
log("url="+url)
log("ticket="+ticket)


dom = xml.dom.minidom.parse(queryFile)
n = dom.getElementsByTagName("responseFormat")[0]
limit = int(n.getAttribute("limit"))

archiveAppend = "0"
while True:

	try:
		# check if cancel
		proc = open(procFilename)
		cancel = proc.read()
		proc.close()
		if cancel == "cancel":
			log("Cancel received.")
			break;
		
		start = int(n.getAttribute("start"))		
		queryData = dom.toxml('utf-8')

		log("Requesting archiving of records " + str(start+1) + " to " + str(start + limit))

		data = urllib.urlencode([('query', queryData)])
		req = urllib2.Request(url + "&archiverequest=1&archiveappend="+archiveAppend+"&archivefilename="+archiveFilename+"&ticket="+ticket)
		fd = urllib2.urlopen(req, data)

		#log("Query data: " + queryData)

		data = fd.read(1024)
		

		r = xml.dom.minidom.parseString(data.encode("utf-8"))
		r.documentElement.tagName == "response"
		#log(logFile, r.toxml())

		hits = 0
		status = "N/A"
		message = "N/A"
		try:
			hits = int(r.getElementsByTagName("hits")[0].firstChild.data)
			status = str(r.getElementsByTagName("status")[0].firstChild.data)
			message = str(r.getElementsByTagName("message")[0].firstChild.data)
		except:
			pass

		fetched = hits - start - 1

		log("" + str(fetched) + " records archived")
		#log("  hits   : "+str(hits))
		log("  status : "+status)
		log("  message: "+message)

		if status != "ok":
			log("ERROR: Return status not ok, aborting")
			break;

		if fetched + 1 <= limit:
			log("Archiving finished with no errors")
			break;

		

		n.removeAttribute("start")
		n.setAttribute("start", str(start + limit))
		archiveAppend = "1"
	except:
		error = str(sys.exc_info()[0]) + "," + str(sys.exc_info()[1]) + "," + str(sys.exc_info()[2]) + "\n"
		log("ERROR: Archiving aborted with error:\n")
		log(error+"\n")
		#raise error
		break;
		

log("Removing proc file.")
os.remove(procFilename)

if cancel == "cancel":
	log("Removing incomplete archive.")
	try:
		os.system('DEL /F /Q "%s"' % path + archiveFilename + ".*")
	except:
		pass

	try:
		os.remove(path + archiveFilename)
		os.remove(configFile)
		os.remove(queryFile)
		os.remove(logFile)
	except:
		pass

	
	

log("EXIT")